/*********************************************************************************************************
*
* File                : main.cpp
* Hardware Environment: 
* Build Environment   : Keil MDK
* Version             : V4.74
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.net
*                                       http://www.waveshare.com
*                                          All Rights Reserved
*
*********************************************************************************************************/
#include "mbed.h"
#include "ADXL345_I2C.H"

/*
variable
*/
Serial uart(USBTX, USBRX);
DigitalOut myled(LED1);
ADXL345_I2C acc(I2C_SDA, I2C_SCL);
int16_t value[3];
int16_t offset[3];
float result[3];


void data_process(void)
{
	int i;
	for(i = 0; i < 3; i++)
	{
		result[i] = (value[i] - offset[i]) * 0.004 * 9.80665;
	}
}

int main(void) 
{
	uart.baud(9600);
	
	acc.setPowerControl(0x00);
	wait_ms(10);
	acc.setDataFormatControl(0x0B);
	wait_ms(10);
	acc.setPowerControl(MeasurementMode);
	wait_ms(10);
	
	/*
	adjust
	*/
	offset[0] = 4;
	offset[1] = 10;
	offset[2] = -20;
	
  while(1) 
	{ 
		wait(0.9);
		
		acc.getOutput(value);
		data_process();
		uart.printf("X= %.1f Y= %.1f Z= %.1f\n", result[0], result[1], result[2]);
    myled = !myled;
  }
}





 

