/*********************************************************************************************************
*
* File                : main.cpp
* Hardware Environment: 
* Build Environment   : Keil MDK
* Version             : V4.74
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.net
*                                       http://www.waveshare.com
*                                          All Rights Reserved
*
*********************************************************************************************************/
#include "mbed.h"
#include "ds3231.h"

#define BUFF_MAX 128
#define CMD_BUFF 20

/*
variable
*/
unsigned long now;
struct ts t;

char in;
char cmd_buff[CMD_BUFF];
unsigned char count = 0, time_tick;
unsigned char cmd_flag = 0;
unsigned char u8_temp, i;
unsigned short u16_temp;
Timer timer;
Serial uart(USBTX, USBRX);
DigitalOut myled(LED1);


int main(void) 
{
	uart.baud(9600);
  DS3231_init(DS3231_INTCN);                                          //interrupt enable
	
	timer.reset();
	timer.start();
  while(1) 
	{ 
		now = timer.read_ms();
		if(now >= 1000)
		{
			DS3231_get(&t);
			uart.printf("%d.%02d.%02d %02d:%02d:%02d\n", t.year, t.mon, t.mday, t.hour, t.min, t.sec);
			myled = !myled;
			timer.reset();
			
			time_tick++;
		}
		
	  /*
		error process
		*/
		if((time_tick >= 2) && (cmd_flag == 1))
		{
			cmd_flag = 0;
			count = 0;
		}		
	
    /*
    if conf time and date
    */
    if(uart.readable())
    {
      if(cmd_flag == 0)
      {
        in = uart.getc();
        if(in == '0')
        {
          cmd_flag = 1;
          time_tick = 0;
        }
      }
      else
      {
        cmd_buff[count++] = uart.getc();
        if(count >= 14)                                    //decode and set time 
        {
          cmd_flag = 0;
          count = 0;
          
          for(i = 0; i < 14; i++)
          {
            cmd_buff[i] -= '0';
          }
          /*
          year
          */
          u16_temp = 0;
          u16_temp += cmd_buff[0] * 1000;
          u16_temp += cmd_buff[1] * 100;
          u16_temp += cmd_buff[2] * 10;
          u16_temp += cmd_buff[3];
          t.year = u16_temp;
          
          /*
          month
          */
          u8_temp = 0;
          u8_temp += cmd_buff[4] * 10;
          u8_temp += cmd_buff[5];
          t.mon = u8_temp;
          
          /*
          day
          */
          u8_temp = 0;
          u8_temp += cmd_buff[6] * 10;
          u8_temp += cmd_buff[7];
          t.mday = u8_temp;
          
          /*
          hour
          */
          u8_temp = 0;
          u8_temp += cmd_buff[8] * 10;
          u8_temp += cmd_buff[9];
          t.hour = u8_temp;
          
          /*
          minute
          */
          u8_temp = 0;
          u8_temp += cmd_buff[10] * 10;
          u8_temp += cmd_buff[11];
          t.min = u8_temp;
          
          /*
          second
          */
          u8_temp = 0;
          u8_temp += cmd_buff[12] * 10;
          u8_temp += cmd_buff[13];
          t.sec = u8_temp;
          
          DS3231_set(t);
        }
      }
    }
		
  }
}





























 

