/*********************************************************************************************************
*
* File                : main.cpp
* Hardware Environment: 
* Build Environment   : Keil MDK
* Version             : V4.74
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.net
*                                       http://www.waveshare.com
*                                          All Rights Reserved
*
*********************************************************************************************************/
#include "mbed.h"

/*
I/O define
*/
#define    KEY_UP        A1
#define    KEY_DOWN      A5
#define    KEY_LEFT      A3
#define    KEY_RIGHT     A2
#define    KEY_ENTER     A4

/*
variable
*/

int key_release_flag = 1, i; 
int time_ticks = 0;

Serial uart(USBTX, USBRX);
DigitalOut myled(LED1);
DigitalIn up(KEY_UP), down(KEY_DOWN), left(KEY_LEFT), right(KEY_RIGHT), enter(KEY_ENTER);

int main(void) 
{
	uart.baud(9600);
	
	/*
	set pin mode
	*/
	up.mode(PullUp);
	down.mode(PullUp);
	left.mode(PullUp);
	right.mode(PullUp);
	enter.mode(PullUp);
	
  while(1) 
	{ 
		/*
		led flash
		*/
		wait_ms(1);
		time_ticks++;  
		if(time_ticks == 500)
		{
			myled = !myled;
			time_ticks = 0;
		}
		
		/*
		keyboard scan
		*/
		if((up == 0) || (down == 0) || (left == 0) || (right == 0) || (enter == 0))
		{
			if(key_release_flag)
			{
				wait_ms(10);
				if((up == 0) || (down == 0) || (left == 0) || (right == 0) || (enter == 0))
				{
					key_release_flag = 0;
					if(up == 0)
						uart.printf("you press UP\n");
					else if(down == 0)
						uart.printf("you press DOWN\n");
					else if(left == 0)
						uart.printf("you press LEFT\n");
					else if(right == 0)
						uart.printf("you press RIGHT\n");
					else if(enter == 0)
						uart.printf("you press ENTER\n");
				}
			}
		}
		else
			key_release_flag = 1;
  }
}





 

