/*********************************************************************************************************
*
* File                : main.cpp
* Hardware Environment: 
* Build Environment   : Keil MDK
* Version             : V4.74
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.net
*                                       http://www.waveshare.com
*                                          All Rights Reserved
*
*********************************************************************************************************/
#include "mbed.h"

#define MCP4725_WRITE  0xC0
#define MCP4725_READ   0xC1
/*
variable
*/
AnalogIn analog(A0);
I2C mcp4725(D14,D15);
PwmOut PWM(D12);

Ticker t;
int i,j,count;
char flag = 0;

const unsigned short Sine12bit[32] = {   //data for sine wave
                      2047, 2447, 2831, 3185, 3498, 3750, 3939, 4056, 4095, 4056,
                      3939, 3750, 3495, 3185, 2831, 2447, 2047, 1647, 1263, 909, 
                      599, 344, 155, 38, 0, 38, 155, 344, 599, 909, 1263, 1647};


void MCPWriteDAC(unsigned short value)    //sent 12-bit value to MCP4725
{
    char data[2];
    data[0] = value >> 12;
    data[1] = value >> 4; 
    mcp4725.write(MCP4725_WRITE, data, 2);
}

void flip() 
{
    PWM.write((float)Sine12bit[j++]/0x1000);       //PWM out for LED ,period 100ms
    if(j==32)j=0;
    if(count++ == 10)
    {
        count=0;
        flag = 1;
    }
}

int main(void) 
{         
    t.attach(&flip,0.1);  //100ms
    while(1) 
    {
        MCPWriteDAC(Sine12bit[i++] << 4);       //DAC out for speaker
        if(i==32)i=0;
        if(flag)
        {
            flag = 0;
            printf("The analog input is :%dmv\r\n",int(analog.read()*3300));  //prinf analog input
        }
    }
}

